before_script:
  - IMAGE_TAG="$(echo $CI_COMMIT_SHA | head -c 8)"

cache:
  paths:
    - maven.repository/

variables:
  MAVEN_OPTS: "-Djava.awt.headless=true -Dmaven.repo.local=maven.repository/"
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version"
  REPOSITORY_URL: 767398144630.dkr.ecr.ap-southeast-2.amazonaws.com/sboot-demo-repo

stages:
  - unit-test
  - package
  - deploy

maven-unit-test:
  image: maven:3.9.8-eclipse-temurin-17
  stage: unit-test
  script:
    - mvn $MAVEN_CLI_OPTS clean test install
    - (cd target; jar -xf *.jar)
  artifacts:
    paths:
      - target/*.jar

build-image:
  image: docker:latest
  stage: package
  services:
    - name: docker:dind
  script:
    - apk add --no-cache curl jq python3 py-pip
    - python3 -m venv /path/to/venv
    - . /path/to/venv/bin/activate
    - pip install awscli
    - $(aws ecr get-login --no-include-email --region ap-southeast-2)
    - docker build -t $REPOSITORY_URL:latest .
    - docker tag $REPOSITORY_URL:latest $REPOSITORY_URL:$IMAGE_TAG
    - docker push $REPOSITORY_URL:latest
    - docker push $REPOSITORY_URL:$IMAGE_TAG


deploy:
  image: python:latest
  stage: deploy
  script:
    - pip install awscli
    - echo $REPOSITORY_URL:$IMAGE_TAG
    - aws ecs update-service --region ap-southeast-2 --cluster MyCluster --service MyService  --task-definition MyTaskDef
